//: C08:Recycle2.cpp
// Z knihy "Myslíme v jazyce C++, část 2" od Bruce Eckela a Chucka Allisona.
// (c) 1995-2004 MindView, Inc. Všechna práva vyhrazena.
// Přečtěte si podmínky používání zdrojových kódů umístěné v souboru 
// 'Licence.txt' dodávaném spolu s balíčkem kódu dostupným na www.MindView.net.
//{L} Trash
// Recyklování s mapou.
#include <cstdlib>
#include <ctime>
#include <iostream>
#include <map>
#include <typeinfo>
#include <utility>
#include <vector>
#include "Trash.h"
#include "../purge.h"
using namespace std;

// Komparátor ukazatelů type_info
struct TInfoLess {
  bool operator()(const type_info* t1, const type_info* t2)
  const { return t1->before(*t2); }
};

typedef map<const type_info*, vector<Kos*>, TInfoLess>
  MapaKose;

// Sums up the hodnota of the Kos in a kos:
void sectiHodnotu(const MapaKose::value_type& p, ostream& os) {
  vector<Kos*>::const_iterator seznam = p.second.begin();
  float hodn = 0;
  while(seznam != p.second.end()) {
    hodn += (*seznam)->vaha() * (*seznam)->hodnota();
    os << "váha: "
       << p.first->name()  // type_info::name()
       << " = " << (*seznam)->vaha() << endl;
    ++seznam;
  }
  os << "Celková hodnota = " << hodn << endl;
}

int main() {
  srand(time(0)); // Inicializace generátoru náhodných čísel
  MapaKose kos;
  // naplnit Kos kos:
  for(int i = 0; i < 30; i++) {
    Kos* ku;
    switch(rand() % 3) {
      case 0 :
        ku = new Hlinik((rand() % 1000)/10.0);
        break;
      case 1 :
        ku = new Papir((rand() % 1000)/10.0);
        break;
      case 2 :
        ku = new Sklo((rand() % 1000)/10.0);
        break;
    }
    kos[&typeid(*ku)].push_back(ku);
  }
  // Print sorted results
  for(MapaKose::iterator p = kos.begin();
      p != kos.end(); ++p) {
    sectiHodnotu(*p, cout);
    purge(p->second);
  }
} ///:~
